class AppRb::Config
  def initialize(yml)
    @body = yml
  end

  def tool_version; @body["tool_version"]; end
  def app; @body["app"]; end
  def consul; @body["consul"]; end
  def registry; @body["registry"]; end
  def user; @body["user"]; end
  def image; @body["image"]; end
  def env; @body["env"] || {}; end
  def pre_deploy; @body["pre_deploy"] || []; end
  def deploy; @body["deploy"] || {}; end
  def cron; @body["cron"] || {}; end
  def run; @body["run"] || {}; end
  def slack_url; @body["slack_url"]; end
  def slack_channel; @body["slack_channel"]; end
  def slack?; slack_url && slack_channel; end

  def nodes(constraint = nil)
    constraint ||= {}
    out = __nodes
    if constraint["name"]
      out = out.select { |n| Array(constraint["name"]).index(n.name) }
    end
    out.shuffle
  end

private

  Node = Struct.new(:name, :ip)
  def __nodes
    @__nodes ||= JSON.load(AppRb::Util.just_cmd("curl -s #{@body["consul"]}/v1/catalog/nodes")).sort_by { |n| 
      n["Node"]
    }.map { |n|
      Node.new(n["Node"], n["Address"])
    }
  end
end
